;----------------------Akkulader Version 1.1----------------------------------
;
;nderungen zu Version 1.0 am 3. 2. 1996:

;Warteschleife nach Tasten einlesen eingebaut (Entprellzeit), da manchmal
;die Tasten bis zu 4 - fach eingelesen wurden
;Akku voll Routine gendert. Einige Akkus zeigen keine Delta Peak
;Kennlinie, der Lader schaltet dann nicht ab. Bei diesen Akkus erhht sich
;dann aber die Ladespannung nicht mehr, diese Eigenschaft kann zur Abschaltung
;des Laders herangezogen werden
;Bei ungerader Zellenanzahl (3,5,7,9) Fehler bei der Berechnung des Peak Werts
;beseitigt
;damit beim laden und entladen das Gert nicht "tot" wirkt wurde ein Lauflicht
;eingebaut.
;Reihenfolge entladen: Ladestrom -> Progwahl -> Zellenanzahl
;Reihenfolge laden: Zellenanzahl -> Progwahl -> Ladestrom
;------------------------------------------------------------------------------
;Ladestrom:
;0 = 10 % kleiner Strom          5 = 10 % groer Strom
;1 = 20 % kleiner Strom          6 = 20 % groer Strom
;2 = 40 % kleiner Strom          7 = 40 % groer Strom -- max. bis 4 Zellen
;3 = 70 % kleiner Strom          8 = 70 % groer Strom
;4 = 100 % kleiner Strom         9 = 100 % groer Strom
;------------------------------------------------------------------------------
;Programme:
;               Prog 1 = laden Delta Peak
;               Prog 2 = laden Delta Peak Reflex
;               Prog 3 = Refresh 1 Zyklus Delta Peak
;               Prog 4 = Refresh 1 Zyklus Delta Peak Reflex
;               Prog 5 = Refresh 2 Zyklen Delta Peak
;               Prog 6 = Refresh 2 Zyklen Delta Peak Reflex
;               Prog 7 = Refresh 3 Zyklen Delta Peak
;               Prog 8 = Refresh 3 Zyklen Delta Peak Reflex
;------------------------------------------------------------------------------
;Portbelegung:
;               P1.0    laden                   P5.0    7 Segment 1
;               P1.1    Ladestrom, 0 = hoch     P5.1    7 Segment 2
;               P1.2    entladen                P5.2    7 Segment 4
;               P2.4    TLC 549 CLC             P5.3    7 Segment 8
;               P2.5    TLC 549 DOUT            P6.3    Lumi laden
;               P2.6    TLC 549 CS              P7.0    Lumi Ladestrom
;               P4.0    Taste Start             P7.1    Lumi Progwahl
;               P4.1    Taste weiter            P7.2    Lumi Zellenanzahl
;               P4.2    Taste +                 P7.3    Lumi entladen
;               P4.3    Taste -
;------------------------------------------------------------------------------
;im Datenspeicher 32 ist der aktuelle Analogwert gespeichert
;im Datenspeicher 33 ist die ermittelte Akkuanzahl gespeichert
;im Datenspeicher 34 ist das aktuelle Programm (Progwahl) gespeichert
;im Datenspeicher 35 ist die Ladestromvorwahl hinterlegt
;   Datenspeicher 36 Speicher alter Analogwert (fr Akku voll)
;   Datenspeicher 37 Zhlwert wieoft ist Delta Peak aufgetreten
;   Datenspeicher 38 Rckmeldung Akku voll Erkennung.
;   0 - nicht voll, Bit 0=1 - Akku voll, Bit 1=1 - Akku weg (abgeklemmt)
;   Datenspeicher 39 Zhler wieviel Lade / Entladezyklen noch ausfhren
;   Datenspeicher 40 Zhlschleife fr Timerinterrupt
;   Datenspeicher 41 - benutzt als "Bitflag"
;                      Bit 0 Akkuanzahl wurde manuell gendert
;                      Bit 1 Nachladeimpuls fr Erhaltensladung
;                      Bit 2 Speicher fr Erhaltensladung
;                      Bit 3 Lader ist im Zustand entladen (Lauflicht)
;                      Bit 4 Lader ist im Zustand laden (Lauflicht)
;                      Bit 5 Speicher fr Lauflicht
;   Datenspeicher 42 "Nachladezhler" fr Erhaltensladung
;   Datenspeicher 43 Startzhler -> Vollauswertung bei neuem Akku um X Zyklen
;                    sperren
;   Datenspeicher 44 Zhler Akku voll wenn die Akkuspannung nicht mehr steigt
;------------------------------------------------------------------------------
;Register 2, RB1 fest belegt
;Register 4, RB0 fest belegt fr Tastenspeicher -> Inhalt nur gltig, wenn
;                Tastenbit 7 gesetzt ist
;------------------------------------------------------------------------------
;F1 ist das "Blinkflag"
;------------------------------------------------------------------------------
;Da der 8243 von Mitshubishi Probleme mit dem Einlesen der Ports hat
;werden alle Ports in Registern gespeichert und mit diesen Registern
;gearbeitet (Prozessabbild...)
;benutzt wird die Registerbank 1, Register R5 - R 7. Die Tasten werden
;nicht abgebildet
;------------------------------------------------------------------------------
;Analogwert: Uref = 5 Volt, Vorteiler = 3,4, 1Increment=0,01953 Volt
;------------------------------------------------------------------------------
DEFAULT_STROM           .EQU 0          ;Lstromvorgabe wenn kein Strom gewhlt
DEFAULT_PROGRAMM        .EQU 2          ;Programmvorgabe -> kein Programm gew.
TIMERINTERRUPT          .EQU 100        ;Timerlaufzeit bis Interrupt
W_WARTE_ANALOG          .EQU 3          ;Wartezeit bis Akkuistwert ermittelt
                                        ;wird (X*255) "Beruhigungszeit Akku"

BLINK                   .EQU 10         ;Blinktimer vorbesetzen (X*10)
ELADEN_LEER_WARTE       .EQU 60         ;Pulsdauer entladen leer (X*255)
ELADEN_REFLEX_IMPULS    .EQU 220        ;Impuls reflexentladen
ELADEN_REFLEX_ZYKLUS    .EQU 30         ;Entladezyklen Reflex (30 Zyklen)
LADEDAUER_ERHALTEN      .EQU 10         ;Ladedauer Erhaltungsladung (10*255)
NACHLADEN_ERHALTEN      .EQU 20         ;ab welcher Spannung wird nachgeladen
TIMER_NACHLADEN         .EQU 3          ;Nachladeimpuls bei (X*F1) wird
                                        ;nachgeladen
LADEZYKLEN              .EQU 150        ;Ladezyklen bis weiter (150)
ANALOG_ZELLENANZAHL     .EQU 17         ;Analog ermitteln Zellenanzahl
ANALOG_ENTLADEN_LEER    .EQU 14         ;Entladeschluspannung pro Zelle
ANALOG_MIN_VOLL         .EQU 21         ;minimale Zellenspannung fr Akku voll
ANALOG_SPANNUNG_VOLL    .EQU 28         ;maximale Spannung -> Akku voll
                                        ;maximal 28 sonst berlauf bei 9 Zellen
STARTZAEHLER_VOLL       .EQU 20         ;nach X Zyklen ist die Vollerkennung
                                        ;aktiv
;                      neu Version 1.1
WARTE_ENTPRELL          .EQU 5          ;Entprellzeit (X*255)
VOLL_KEIN_DELTA_PEAK:   .EQU 45         ;Zhler Akku voll wenn sich die Akku-
                                        ;spannung whrend X Ladezyklen
                                        ;nicht mehr erhht
                        .ORG 0
                JMP BEGINN

                        .ORG 7
                CALL TIMER              ;Timerinterrupt
                RETR
                        .ORG 30
                .TEXT     --== Akkulader Version 1.1 ==--
                        .ORG 100
                .TEXT ----==== (C) Thomas WAGNER ====----
                        .ORG 200
                .TEXT             --==  3. 2.1996 ==--

                        .ORG 256
BEGINN:         CALL INIT               ;Initialisierung

;---------------------------HAUPTPROGRAMM--------------------------------------

;----------Akkuanzahl ermitteln und anzeigen----------
START:          CALL ANALOG             ;Analogwert einlesen
                CALL AKKUANZAHL         ;Zellenanzahl ermitteln
                CALL AUS_AKKU_BLINK     ;Akkus auf 7 Segment, Blink bei Fehler
;----------Bitspeicher Akkuanzahl manuell gendert lschen----------
                MOV R0,#41              ;Flagspeicher ffnen
                MOV A,@R0               ;und laden
                ANL A,#%11100000        ;Bits Akkuanzahl / Erh.ladung
                MOV @R0,A               ;Lauflicht lschen und zurckschreiben
;----------Delta Peak Speicher und alten Analogspeicher lschen----------
;---------------Voreinstellungen fr jeden Start vornehmen---------------
                MOV R0,#36              ;Datenspeicher
                MOV @R0,#0              ;alter Analogwert lschen
                MOV R0,#37              ;Datenspeicher
                MOV @R0,#0              ;Delta Peak lschen
                MOV R0,#39              ;Datenspeicher
                MOV @R0,#0              ;Zykluszhler lschen
                MOV R0,#43              ;Datenspeicher Start bis Vollerkennung
                MOV @R0,#STARTZAEHLER_VOLL ;vorbesetzen
                MOV R0,#44              ;Datenspeicher Abschaltung wenn kein
                MOV @R0,#VOLL_KEIN_DELTA_PEAK ;Delta Peak vorbesetzen
;----------Tasten einlesen--------------
h_taste_0:      CALL TASTEN             ;Tasten abfragen
                MOV A,R4                ;Tastenspeicher laden
                JB7 h_taste_1           ;Abfrage, ob Tastenbit gltig
                MOV R0,#41              ;Flagspeicher ffnen
                MOV A,@R0               ;und laden
                JB0 h_taste_1           ;Akkuanzahl manuell gendert
                JMP START               ;keine Taste gedrckt
;----------Akkuanzahl eingeben----------
h_taste_1:      CALL EIN_AKKUANZAHL     ;Eingabemglichkeit Zellenanzahl
                CALL AUS_AKKU_BLINK     ;Eingabe anzeigen, Blink bei Fehler
                MOV R0,#41              ;Flagspeicher ffnen
                MOV A,@R0               ;und laden
                ORL A,#%00000001        ;Akkuanzahl gendert setzen
                MOV @R0,A               ;und zurckschreiben
                MOV R0,#33              ;Speicher Akkuanzahl ffnen
                MOV A,@R0               ;und laden
                CLR C
                CPL A
                ADD A,#2                ;vom Akku 2 abziehen
                CPL A
                JC h_taste_0            ;wenn Carry 1 Start/weiter sperren
                MOV A,R4                ;Tastenspeicher einlesen
                JB0 h_taste_start       ;Taste Start gedrckt
                JB1 h_taste_w_1         ;Taste weiter gedrckt
                JMP h_taste_0           ;Tasten neu einlesen
h_taste_start:  CALL DEFAULT            ;Taste Start gedrckt -> Defaultwerte
                JMP h_laden_ein         ;Akku aufladen
;----------Ladeprogramm auswhlen und anzeigen----------
h_taste_w_1:    CALL EIN_PROGWAHL       ;Programm kann angewhlt werden
                CALL AUS_PROGWAHL       ;Programmwahl auf 7 Segment anzeigen
                CALL TASTEN             ;Tasten abfragen
                MOV A,R4                ;Tastenspeicher laden
                JB7 h_taste_2           ;Abfrage, ob Tastenbit gltig
                JMP h_taste_w_1         ;keine Taste gedrckt
h_taste_2:      JB2 h_taste_w_1         ;Taste + gedrckt -> ignorieren
                JB3 h_taste_w_1         ;Taste - gedrckt -> ignorieren
                JB1 h_taste_w_2         ;Taste weiter gedrckt
                CALL DEFAULT            ;Taste Start gedrckt -> Defaultwerte
                JMP h_laden_ein         ;Akku aufladen
;----------Ladestrom auswhlen und anzeigen----------
h_taste_w_2:    CALL EIN_LADESTROM      ;Anwahl Ladestrom
                CALL AUS_LSTROM         ;Ladestrom auf 7 Segment anzeigen
                CALL TASTEN             ;Tasten abfragen
                MOV A,R4                ;Tastenspeicher laden
                JB7 h_taste_3           ;Abfrage, ob Tastenbit gltig
                JMP h_taste_w_2         ;keine Taste gedrckt
h_taste_3       JB2 h_taste_w_2         ;Taste + gedrckt
                JB3 h_taste_w_2         ;Taste - gedrckt
                JB1 START               ;Taste weiter -> alles wieder von vorn
;---------Anzahl Lade/Entladezyklen ermitteln----------
h_laden_ein:    CALL CHECK_ZYKLEN       ;Anzahl Lade / Entladezyklen ermitteln
                MOV R0,#34              ;Programmspeicher ffnen
                MOV A,@R0               ;und laden
                DEC A
                JZ n_entladen           ;Programm 1 -> nicht vorentladen!
                DEC A
                JZ n_entladen           ;Programm 2 -> nicht vorentladen!
;----------Akku entladen----------
h_zyklus_neu:   MOV R1,#41              ;im Datenspeicher 41
                MOV A,@R1               ;Bit 3
                ORL A,#%00001000        ;= entladen setzen
                ANL A,#%11101111        ;Bit 4 = laden
                MOV @R1,A               ;rcksetzen
                CALL ENTLADEN_LEER      ;Akku bis zur Entladespannung leeren
;----------Akku laden----------
n_entladen:     MOV R1,#41              ;im Datenspeicher 41
                MOV A,@R1               ;Bit 4
                ORL A,#%00010000        ;= laden setzen
                ANL A,#%11110111        ;Bit 3 = entladen
                MOV @R1,A               ;rcksetzen
                CALL LADEN              ;Akku aufladen
                MOV R0,#38              ;Rckmeldespeicher ffnen
                MOV A,@R0               ;und laden
                JB1 START               ;Akku abgeklemmt! -> wieder von vorn!
                MOV R0,#39              ;Zyklenzhler ffnen
                MOV A,@R0               ;und laden
                DEC A                   ;um 1 reduzieren
                MOV @R0,A               ;zurckschreiben
                JNZ h_zyklus_neu        ;einen neuen Zyklus starten
;----------Erhaltensladung----------
                MOV R1,#41              ;im Datenspeicher 41
                MOV A,@R1               ;Bit 3 und 4
                ANL A,#%11100111        ;laden / entladen
                MOV @R1,A               ;rcksetzen
                CALL LUMIS_LAUF_AUS     ;und Lauflichtled's lschen
                CALL ERH_LADUNG         ;Ladezustand erhalten
                JMP START               ;alles wieder von vorn
;---------------------------Ende Hauptprogramm---------------------------------

;--ANALOG-- Analogwert einlesen und im Datenspeicher 32 sichern

ANALOG:         CALL WARTE_ANALOG
                MOV R2,#8               ;Zhlregister vorbesetzen
                MOV R5,#0               ;Analogregister lschen
neues_bit:      MOV A,#%10101111        ;549 CS und CLC auf 0
                OUTL P2,A
                MOV A,R5                ;Analogregister
                RL A                    ;um 1 Stelle nach links schieben
                MOV R5,A                ;und zurckschreiben
                IN A,P2                 ;Port 2 einlesen
                SWAP A                  ;Nibbles im Akku tauschen
                RR A                    ;und um 1 Stelle schieben
                                        ;Analogbit ist jetzt im Akkubit 0
                ANL A,#%00000001        ;alle anderen Akkubits lschen
                ORL A,R5                ;ODER Akku mit Analogregister
                MOV R5,A                ;Ergebnis im Analogregister speichern
                MOV A,#%10111111        ;CLC auf 1
                OUTL P2,A
                DJNZ R2,neues_bit       ;Zhlregister -1 und prfen
                MOV A,#%11101111
                OUTL P2,A               ;549 CLC auf 0 und CS auf 1 setzen
                MOV R0,#32              ;Datenspeicher 32 anwhlen
                MOV A,R5                ;Analogwert laden
                MOV @R0,A               ;Analogwert im Datenspeicher 32 sichern
                RETR

;--AKKUANZAHL-- ermittelt die Anzahl der Zellen, Anzahl im Datenspeicher 33

AKKUANZAHL:     CALL L_ZELLEN_EIN       ;Lumi Zellenanzahl einschalten
                MOV R0,#32              ;Datenspeicher 32 anwhlen
                MOV A,@R0               ;aktuellen Analogwert in den Akku
                MOV R6,#0               ;Register R6 lschen
                CLR C                   ;Carrybit lschen
naechster_Akku: CPL A                   ;vom Akku
                ADD A,#ANALOG_ZELLENANZAHL ;ANALOG_ZELLENANZAHL
                CPL A                   ;abziehen
                JC anzahl               ;wenn Carry gesetzt ist die Akkuanzahl
                                        ;ermittelt
                INC R6                  ;ermittelte Zellenanzahl +1
                JMP naechster_Akku
anzahl:         MOV R0,#33              ;Datenspeicher 33 anwhlen
                MOV A,R6                ;ermittelte Akkuanzahl
                MOV @R0,A               ;in Datenspeicher 33 speichern
                RETR

;--AUS_AKKU_BLINK-- die Akkuanzahl auf 7 Segment ausgeben ->Fehler Blink

AUS_AKKU_BLINK: MOV R0,#33              ;Datenspeicher 33 anwhlen
                MOV A,@R0               ;ermittelte Akkuanzahl laden
                MOV R7,A                ;im Register 7 speichern
                JZ fehler_anzahl        ;wenn Akku 0 Volt hat
                DEC A                   ;Akku -1
                JZ fehler_anzahl        ;wenn nur 1 Akku erkannt wurde
                INC A                   ;Akku +1
                CPL A                   ;vom Akku 10
                ADD A,#10               ;abziehen
                CPL A
                JC anzahl_ok            ;Akkuanzahl ist o.K.
fehler_anzahl:  JF1 anzahl_ok           ;wenn Flag 1 gesetzt ist, 7 Segment an
                SEL RB1
                MOV R5,#%11111111       ;Akku auf 1
                SEL RB0                 ;Port 5 auf 1 (blink)
                JMP zurueck_anzahl
anzahl_ok:      MOV A,R7                ;Akkuanzahl laden
                SEL RB1
                MOV R5,A                ;und auf 7 Segment anzeigen
                SEL RB0
zurueck_anzahl: RETR

;--AUS_PROGWAHL-- gewhltes Programm auf die 7 Segment Anzeige

AUS_PROGWAHL:   MOV R0,#34              ;Datenspeicher 34 anwhlen
                MOV A,@R0               ;und Wert auf die
                SEL RB1                 ;Anzeige rausschreiben
                MOV R5,A
                SEL RB0
                RETR

;--TASTEN-- ermittelt die gedrckte Taste und speichert im Register 4
;-----------Inhalt nur gltig, wenn Bit 7 gesetzt ist (Flanke)

TASTEN:         MOVD A,P4               ;Tastenport einlesen
                MOV R6,A                ;und sichern
                CPL A                   ;da die Tasten nach minus schalten
                ANL A,#%00001111        ;nicht benutzte Bits lschen
                JZ keine_taste          ;keine Taste wurde gedrckt
                MOV A,R4                ;Tastenspeicher laden
                JB7 tastenbit           ;prfe, ob Tastenbit gesetzt ist
                JB6 ende_tasten         ;wenn Tastenflankenbit gesetzt -> Ende
                MOV A,R6                ;Tasten einlesen
                CPL A                   ;die Tasten schalten minus
                ANL A,#%00001111        ;nicht benutzte Bits lschen
                ORL A,#%10000000        ;Tastenbit (gltig) setzen
                MOV R4,A                ;Tasten speichern
                JMP ende_tasten         ;und beenden
tastenbit:      MOV A,R4                ;Tastenspeicher laden
                ORL A,#%01000000        ;Tastenflankenbit setzen
                ANL A,#%01111111        ;Tastenbit (gltig) lschen
                MOV R4,A                ;Wert zurckschreiben
                JMP ende_tasten         ;und beenden
keine_taste:    MOV R4,#0               ;Tastenspeicher lschen
ende_tasten:    CALL ENTPRELL           ;Warteschleife
                RETR

;--EIN_PROGRAMMWAHL-- speichert das gewhlte Programm im Datenspeicher 34

EIN_PROGWAHL:   CALL L_PROG_EIN         ;Lumi Programmwahl einschalten
                MOV A,R4                ;Tastenspeicher laden
                CPL A
                JB7 ende_progwahl       ;Tasten ungltig -> beenden
                CPL A
                JB2 t_plus_prog         ;Taste + gedrckt
                JB3 t_minus_prog        ;Taste - gedrckt
                JMP ende_progwahl       ;Taste irrelevant, beenden
t_plus_prog:    CLR C
                MOV R0,#34              ;Datenspeicher Programmwahl
                MOV A,@R0               ;laden
                CPL A
                ADD A,#8                ;vom Akku 8 abziehen
                CPL A
                JNC ende_progwahl       ;wenn Carry 0 maxWert (8) erreicht
                MOV A,@R0
                INC A                   ;Akku +1
                MOV @R0,A               ;Wert zurckschreiben
                JMP ende_progwahl       ;und beenden
t_minus_prog:   CLR C
                MOV R0,#34              ;Datenspeicher Programmwahl
                MOV A,@R0               ;laden
                CPL A                   ;vom alten Wert
                ADD A,#2                ;2 abziehen
                CPL A
                JC ende_progwahl        ;wenn Carry 1 minWert (1) erreicht
                MOV A,@R0
                DEC A                   ;Akku -1
                MOV @R0,A               ;Wert zurckschreiben
ende_progwahl:  RETR


;--EIN_LADESTROM-- speichert den gewhlten Strom im Datenspeicher 35

EIN_LADESTROM:  CALL L_STROM_EIN        ;Lumi Ladestrom einschalten
                MOV A,R4                ;Tastenspeicher laden
                CPL A
                JB7 ende_ladestrom      ;Tasten ungltig -> beenden
                CPL A
                JB2 t_plus_lstrom       ;Taste + gedrckt
                JB3 t_minus_lstrom      ;Taste - gedrckt                      
                JMP ende_ladestrom      ;Taste irrelevant, beenden             
t_plus_lstrom:  CLR C                                                          
                MOV R0,#35              ;Datenspeicher Ladestrom               
                MOV A,@R0               ;laden                                 
                CPL A                                                          
                ADD A,#9                ;vom Akku 9 abziehen
                CPL A                                                          
                JNC ende_ladestrom      ;wenn Carry 0 maxWert (9) erreicht
                CLR C
                MOV R1,#33              ;Datenspeicher Akkuanzahl ffnen
                MOV A,@R1               ;und laden
                CPL A                   ;4
                ADD A,#4                ;abziehen
                CPL A
                JNC erhhen_ok          ;CARRY 0  >= 4 Akkus dran
                MOV A,@R0               ;jetzigen Ladestrom laden
                CPL A
                ADD A,#7                ;7 abziehen
                CPL A
                JC erhhen_ok           ;CARRY = 1 -> jetzige Stromwahl <7
                JMP ende_ladestrom
erhhen_ok:     MOV A,@R0
                INC A                   ;Akku +1                               
                MOV @R0,A               ;Wert zurckschreiben                  
                JMP ende_ladestrom      ;und beenden
t_minus_lstrom: CLR C
                MOV R0,#35              ;Datenspeicher Ladestrom
                MOV A,@R0               ;laden                                 
                JZ ende_ladestrom       ;wenn Akku 0 minWert (0) erreicht
                DEC A                   ;Akku -1
                MOV @R0,A               ;Wert zurckschreiben                  
ende_ladestrom: RETR                                                           


;--ERH_LADUNG-- Erhaltensladung

ERH_LADUNG:     CALL L_LADEN_BLINK      ;Ladelumi blinken lassen
                CALL ANALOG             ;Istwert Akkuspannung ermitteln
                CALL ANALOG_AUS         ;Analogwert rausschreiben
                MOV R0,#33
                MOV A,@R0               ;ermittelte Akkuanzahl laden
                MOV R6,A                ;im Register 6 speichern
                MOV R0,#32              ;aktuellen Analogwert
                MOV A,@R0               ;holen
                CLR C
                CPL A                   ;vom Akku
                ADD A,#20               ;20 Incremente abziehen
                CPL A
                JC erh_akku_weg         ;wenn Carry 1 wurde Akku abgeklemmt
                CALL S_ERH_LADUNG       ;Wartezeit Erhaltensladeimpuls
                MOV R1,#41              ;Flagspeicher
                MOV A,@R1               ;laden
                JB1 nachladen           ;wenn Bit 1 gesetzt -> nachladen!
                MOV R0,#32              ;aktuellen Analogwert
                MOV A,@R0               ;holen
neuer_akku:     CPL A
                ADD A,#NACHLADEN_ERHALTEN
                CPL A                   ;
                JC nachladen            ;wenn Carry 1 mu nachgeladen werden
                DJNZ R6,neuer_akku
                JMP ERH_LADUNG          ;neuen Analogwert ermitteln
nachladen:      ANL P1,#%11111110       ;Ladestrom einschalten
                MOV R6,#LADEDAUER_ERHALTEN
erhalten_1:     MOV R3,#255             ;Zeitschleife
erhalten:       DJNZ R3,erhalten        ;nachladen
                DJNZ R6,erhalten_1
                ORL P1,#%00000001       ;Ladestrom ausschalten
                MOV R3,#255
erhalten_2:     DJNZ R3,erhalten_2      ;Warteschleife neu messen
                JMP ERH_LADUNG
erh_akku_weg:   CALL LUMIS_AUS
                RETR

;--E_LADEN_REFLEX-- generiert Entladeimpulse (Reflexladen)

E_LADEN_REFLEX: CALL L_ELADEN_EIN       ;Lumi entladen ein
                MOV R6,#ELADEN_REFLEX_ZYKLUS
neuer_e_zyklus: ANL P1,#%11111011       ;entladen ein
                MOV R3,#ELADEN_REFLEX_IMPULS
reflex_ein:     DJNZ R3,reflex_ein
                ORL P1,#%00000100       ;entladen aus
                MOV R3,#ELADEN_REFLEX_IMPULS
reflex_aus:     DJNZ R3,reflex_aus
                DJNZ R6,neuer_e_zyklus
                CALL LUMIS_AUS          ;Lumis ausschalten
                RETR

;--INIT-- wird nach Reset ausgefhrt, alle Ports auf 1, Timer vorbesetzen

INIT:           MOV A,#255              ;alle Ports auf 1 setzen
                OUTL P1,A
                OUTL P2,A
                MOVD P4,A
                SEL RB1                 ;Registerbank 1 anwhlen
                MOV R5,A
                MOV R6,A
                MOV R7,A
                MOV R2,#BLINK           ;Blinkregister laden (Schleife 2)
                MOV A,#TIMERINTERRUPT
                MOV T,A                 ;Timer vorbesetzen
                MOV R0,#40
                MOV @R0,#10             ;Blinkspeicher laden (Schleife 1)
                EN TCNTI                ;Timerinterrupt freigeben
                STRT T                  ;Timer starten
                MOV R0,#34
                MOV @R0,#DEFAULT_PROGRAMM
                MOV R0,#35
                MOV @R0,#DEFAULT_STROM
                SEL RB0
                MOV R0,#42               ;Datenspeicher 42 ("Nachladezeit")
                MOV @R0,#TIMER_NACHLADEN ;Erhaltensladung vorbesetzen
                RETR

;--ENTLADEN_LEER-- entld den Akku bis zur Entladeschluspannung

ENTLADEN_LEER:  CALL L_ELADEN_EIN       ;Lumi entladen einschalten
e_eladen:       ANL P1,#%11111011       ;Entladen ein
                MOV R3,#ELADEN_LEER_WARTE ;Entladezeit
e_warte_1:      MOV R6,#255               ;warten
e_warte:        DJNZ R6,e_warte
                DJNZ R3,e_warte_1
                CALL ANALOG             ;Akkuspannung ermitteln
                CALL ANALOG_AUS         ;Wert rausschreiben
                MOV R0,#33              ;errechnete Akkuanzahl
                MOV A,@R0               ;im Register 6
                MOV R6,A                ;speichern
                MOV R0,#32              ;gemessenen Analogwert
                MOV A,@R0               ;laden
                CLR C
e_neuer_akku:   CPL A                   ;vom Akku
                ADD A,#ANALOG_ENTLADEN_LEER ; ANALOG_ENTLADEN_LEER
                CPL A                   ;abziehen
                JC e_akku_leer          ;wenn Carry gesetzt -> Akku leer
                DJNZ R6,e_neuer_akku    ;nchsten Wert abziehen
                ORL P1,#%00000100       ;Entladen aus
                MOV R1,#2
e_warte_elad_1: MOV R3,#255
e_warte_eladen: DJNZ R3,e_warte_eladen  ;Warteschleife (Watchdog!)
                DJNZ R1,e_warte_elad_1
                JMP e_eladen
e_akku_leer:    ORL P1,#%00000100       ;Entladen aus
                CALL LUMIS_AUS
                RETR

;--DEFAULT-- Ladestrom und Programmwahl vorbesetzen

DEFAULT:        MOV R1,#35              ;Datenspeicher Ladestrom ffnen
                MOV A,@R1               ;und prfen, ob Wert drin
                JNZ d_strom_ok          ;Strom bereits angewhlt
                MOV @R1,#DEFAULT_STROM  ;Defaultstromwert eintragen
d_strom_ok:     MOV R1,#34              ;Datenspeicher Programmwahl ffnen
                MOV A,@R1               ;und prfen ob Wert drin
                JNZ d_prog_ok           ;Programm bereits gewhlt
                MOV @R1,#DEFAULT_PROGRAMM ;Defaultprogramm eintragen
d_prog_ok:      RETR

;-- AKKU_VOLL -- Erkennung, ob der Akku vollstndig geladen wurde

AKKU_VOLL:      CALL ANALOG             ;aktuelle Akkuspannung ermitteln
                CALL ANALOG             ;2 * aufrufen, da der 549`er schon
                                        ;bei der Datenbertragung den nchsten
                                        ;Wert wandelt und speichert
                CALL ANALOG_AUS         ;Analogwert auf 7 Segment
                MOV R0,#33              ;Datenspeicher Akkuanzahl
                MOV A,@R0               ;laden
                MOV R6,A                ;in's Register 6
                MOV R1,#32              ;Datenspeicher aktuelle Akkuspannung
                MOV A,@R1               ;aktuelle Akkuspannung laden
                CLR C
                MOV R3,#0               ;R3 lschen
p_neue_zelle:   CPL A                   ;berechne die Anzahl
                ADD A,#ANALOG_ZELLENANZAHL
                CPL A                   ;der angeschlossenen Zellen
                JC p_anzahl_erm         ;Carry 1 -> Anzahl ermittelt
                INC R3
                JMP p_neue_zelle
p_anzahl_erm:   CLR C
                MOV A,R3                ;ermittelte Zellenanzahl laden
                CPL A
                ADD A,@R0               ;vorgewhlte Zellenanzahl abziehen
                CPL A
                JC voll_akku_weg        ;die Vorwahl ist grer als die
                                        ;errechnete (gemessene) Anzahl -> raus!
                MOV R1,#43              ;Datenspeicher 43 (Vollroutine bei
                MOV A,@R1               ;neuem Akku sperren) laden
                DEC A                   ;-1
                JZ startz_ok            ;Zhler abgelaufen -> Vollroutine aktiv
                MOV @R1,A               ;und zurckschreiben
                JMP nicht_voll          ;Startzhler neuer Akku noch nicht aktiv
startz_ok:      MOV R1,#32              ;Datenspeicher Akkuspannung anwhlen
                MOV A,@R1               ;Akkuspannung laden
voll_neu:       CPL A
                ADD A,#ANALOG_MIN_VOLL  ;prfe, ob die minimale
                CPL A                   ;Ladespannung schon erreicht ist
                JC nicht_voll           ;wenn Carry 1 Spannung nicht erreicht
                DJNZ R6,voll_neu
                MOV A,@R0               ;Akkuanzahl in's Register
                MOV R6,A                ;6 kopieren
                MOV A,#0                ;Akku lschen
v_anzahl:       ADD A,#ANALOG_SPANNUNG_VOLL ;maximale Ladeschlusspannung
                DJNZ R6,v_anzahl        ;berechnen
                MOV R6,A                ;Ergebnis in's Register 6
                MOV A,@R1               ;Analogwert laden
                CPL A
                ADD A,R6                ;errechneten max.Wert abziehen
                CPL A
                JNC akku_voll           ;wenn Carry 0 -> Akku voll!

;-------neu Version 1.1---------------------------------------------
                MOV R0,#32              ;aktuelle Akkuspannung
                MOV R1,#36              ;Akkuspitzenspannung
                MOV A,@R1               ;Akkuspitzenspannung laden
                CLR C                   ;Carry lschen
                CPL A                   ;aktuelle
                ADD A,@R0               ;Akkuspannung
                CPL A                   ;abziehen
                JZ p_voll_v_peak        ;Akkuspannung = Spitzenspannung
                JC p_voll_v_peak        ;Akkuspannung < Spitzenspannung
                MOV R0,#44              ;Akkuspannung > als grte Spitzensp.
                MOV @R0,#VOLL_KEIN_DELTA_PEAK           ;Zhler neu laden
                JMP routine_peak        ;weiter -> nchstes Abschaltkriterium
p_voll_v_peak:  MOV R0,#44              ;Zhler voll kein Peak
                MOV A,@R0               ;laden
                DEC A                   ;minus 1
                JZ akku_voll            ;wenn Zhler 0 > Akku voll!
                MOV @R0,A               ;neuen Zhlstand sichern
;-------ab hier wieder Version 1.0--------------------------------------
routine_peak:   MOV R1,#36              ;alten Analogwert
                MOV A,@R1               ;laden
                MOV R0,#32              ;Datenspeicher Akkuistspannung
                CLR C
                CPL A                   ;und aktuellen Analogwert
                ADD A,@R0               ;davon abziehen
                CPL A
                JZ nicht_voll           ;wenn Ergebnis 0 -> nicht voll
                JNC voll_kleiner        ;der neue Wert ist kleiner
                JMP nicht_voll          ;der neue Wert ist grer
voll_kleiner:   MOV R0,#32              ;Datensp. Analogwert ffnen
                MOV R1,#33              ;Datenspeicher Akkuanzahl ffnen
                MOV A,@R1               ;und laden
                RR A                    ;durch 2 teilen
                ANL A,#%01111111        ;Bit 7 lschen (wenn Bit 0 gesetzt war)
                ADD A,@R0               ;Ergebnis zum Analogistwert addieren
                MOV R6,A                ;Ergebnis in's Register 6 (Peakwert)
                MOV R0,#36              ;Datensp. alter Analogwert ffnen
                MOV A,@R0               ;und laden
                CLR C
                CPL A                   ;vom alten Analogwert
                ADD A,R6                ;errechneten Peakwert
                CPL A                   ;abziehen
                JNC peak_erreicht       ;der Peak war gro genug
                JC peak_nicht_err       ;der Peak war noch zu klein
peak_erreicht:  MOV R0,#37
                MOV A,@R0               ;Zhler wieoft kleiner laden
                DEC A                   ;vom Zhlwert
                DEC A                   ;3 abziehen
                DEC A
                JZ akku_voll            ;wenn Ergebnis 0 -> Akku voll
                INC @R0                 ;Zhler um 1 erhhen
                JMP voll_ende           ;der Akku ist noch nicht geladen
nicht_voll:     MOV R0,#32              ;aktuellen
                MOV A,@R0               ;Analogwert
                MOV R0,#36              ;im Analogspeicher
                MOV @R0,A               ;sichern
peak_nicht_err: MOV R0,#37              ;Delta Peak Zhler ffnen
                MOV @R0,#0              ;Delta Peak Zhler lschen
                JMP voll_ende
akku_voll:      MOV R0,#38              ;Rckmeldespeicher ffnen
                MOV @R0,#%00000001      ;Bit 0 = Akku voll setzen
                JMP voll_ende_1
voll_akku_weg:  MOV R0,#38              ;Rckmeldespeicher ffnen
                MOV @R0,#%00000010      ;Bit 1 = Akku entfernt setzen
                JMP voll_ende_1
voll_ende:      MOV R0,#38              ;Rckmeldespeicher ffnen
                MOV @R0,#0              ;Rckmeldespeicher lschen
voll_ende_1:    RETR

;--REGISTER_PORTS-- Prozessabbild fr 8243

REGISTER_PORTS: MOV A,R5                ;Werte
                MOVD P5,A               ;8243 aktualisieren
                MOV A,R6
                MOVD P6,A
                MOV A,R7
                MOVD P7,A
                RETR

;--L_ZELLEN_EIN-- Lumi Zellenanzahl einschalten

L_ZELLEN_EIN:   SEL RB1
                MOV R7,#%11111011       ;Bit 2 auf 0
                SEL RB0
                RETR

;--L_STROM_EIN-- Lumi Ladestrom einschalten

L_STROM_EIN:    SEL RB1
                MOV R7,#%11111110       ;Bit 0 auf 0
                SEL RB0
                RETR

;--L_PROG_EIN-- Lumi Programmwahl einschalten

L_PROG_EIN:     SEL RB1
                MOV R7,#%11111101       ;Bit 1 auf 0
                SEL RB0
                RETR

;--L_ELADEN_EIN-- Lumi entladen einschalten

L_ELADEN_EIN:   SEL RB1
                MOV A,R7
                ANL A,#%11110111       ;Bit 3 auf 0
                MOV R7,A
                SEL RB0
                RETR

;--L_LADEN_EIN-- Lumi laden einschalten

L_LADEN_EIN:    SEL RB1
                MOV R6,#%11110111       ;Bit 3 auf 0
                SEL RB0
                RETR

;--LUMIS_AUS-- alle Lumis auer Lauflicht ausschalten

LUMIS_AUS:      SEL RB1
                MOV R6,#%11111111       ;alle Lumibits Port 6 auf 1
                MOV A,R7
                ORL A,#%00001000        ;wegen Lauflicht der LED'S P7.0 - 7.2
                MOV R7,A                ;nur P7.3 zurcksetzen
                SEL RB0
                RETR

;--LUMIS_LAUF_AUS-- Lauflichtlumis ausschalten

LUMIS_LAUF_AUS: SEL RB1
                MOV A,R7
                ORL A,#%11110111        ;Lauflichtlumis ausschalten
                MOV R7,A
                SEL RB0
                RETR

;--L_LADEN_BLINK-- Lumi laden blinken lassen

L_LADEN_BLINK:  SEL RB1
                JF1 l_l_aus
                MOV R6,#%11110111       ;Bit 3 auf 0
                JMP l_l_b_zurck
l_l_aus         MOV R6,#%11111111       ;Bit 3 auf 1
l_l_b_zurck:   SEL RB0
                RETR

;--WARTE_ANALOG-- Wartezeit Analogwert einlesen

WARTE_ANALOG:   MOV R0,#W_WARTE_ANALOG
A_warte_1:      MOV R3,#255
A_warte:        DJNZ R3,A_warte
                DJNZ R0,A_warte_1
                RETR

;--LADEN_WARTE-- Wartezeit fr Ladezyklus, im Register 5 Hauptwarteschleife

LADEN_WARTE:    MOV R3,#50
warten_lade:    DJNZ R3,warten_lade
                RETR

; -- LADEN -- Akku laden (Reflex und normal) Routine wird nur verlassen,
;             wenn Akku voll oder Akku abgeklemmt ist. Zustand kann am
;             Datenspeicher 38 erkannt werden

LADEN:          CALL LUMIS_AUS
                MOV R0,#35              ;Datenspeicher Stromwahl ffnen
                MOV A,@R0
                CLR C                   ;prfe, welcher Strombereich
                CPL A                   ;gewhlt ist
                ADD A,#5
                CPL A
                JC strom_nieder         ;kleinen Strombereich gewhlt
                ANL P1,#%11111101       ;P1.1 auf 0 = hoher Ladestrom
                JMP laden_start
strom_nieder:   ORL P1,#%00000010       ;P1.1 auf 1 = niedriger Ladestrom
laden_start:    CALL L_LADEN_EIN
                CALL SUB_LADEN          ;Laderoutine starten
                CALL AKKU_VOLL          ;prfe, ob Akku geladen ist
                MOV R0,#38              ;Rckmeldespeicher ffnen
                MOV A,@R0
                JB0 l_akku_voll         ;Bit 0 -> Akku gefllt
                JB1 l_akku_weg          ;Bit 1 -> Akku wurde abgeklemmt
                MOV R0,#34              ;Datenspeicher Programmwahl ffnen
                MOV A,@R0
                DEC A
                DEC A
                JZ reflex               ;berprfe,
                DEC A                   ;ob ein
                DEC A                   ;Reflexladeprogramm
                JZ reflex               ;angewhlt
                DEC A                   ;ist
                DEC A
                JZ reflex
                DEC A
                DEC A
                JZ reflex
                MOV R3,#100
l_warte:        DJNZ r3,l_warte         ;Warteschleife (Watchdog)
                JMP laden_start         ;neuen Zyklus einleiten
reflex:         CALL LUMIS_AUS
                CALL E_LADEN_REFLEX     ;Akku -> Entladepulse
                MOV R3,#100
l_warte_1:      DJNZ R3,l_warte_1       ;Warteschleife (Watchdog)
                JMP laden_start         ;neuen Zyklus einleiten
l_akku_weg:
l_akku_voll:    CALL LUMIS_AUS
                RETR

;-- SUB_LADEN -- Ladestromdecoder / Akku laden - 1 kompletter Ladezyklus

SUB_LADEN:      MOV R0,#35              ;Datenspeicher Ladestrom ffnen
                MOV A,@R0               ;und laden
                JZ zehn                 ;Strom 1 zehn Prozent gewhlt
                DEC A
                JZ zwanzig              ;Strom 1 zwanzig Prozent gewhlt
                DEC A
                JZ vierzig              ;Strom 1 vierzig Prozent gewhlt
                DEC A
                JZ siebzig              ;Strom 1 siebzig Prozent gewhlt
                DEC A
                JZ hundert              ;Strom 1 hundert Prozent gewhlt
                DEC A
                JZ zehn                 ;Strom 2 zehn Prozent gewhlt
                DEC A
                JZ zwanzig              ;Strom 2 zwanzig Prozent gewhlt
                DEC A
                JZ vierzig              ;Strom 2 vierzig Prozent gewhlt
                DEC A
                JZ siebzig              ;Strom 2 siebzig Prozent gewhlt
                DEC A
                JZ hundert              ;Strom 2 hundert Prozent gewhlt
zehn:           MOV R7,#10              ;Strom 10 : 90
                MOV R6,#90
                JMP strom_gewhlt
zwanzig:        MOV R7,#20              ;Strom 20 : 80
                MOV R6,#80
                JMP strom_gewhlt
vierzig:        MOV R7,#40              ;Strom 40 : 60
                MOV R6,#60
                JMP strom_gewhlt
siebzig:        MOV R7,#70              ;Strom 70 : 30
                MOV R6,#30
                JMP strom_gewhlt
hundert:        MOV R7,#100             ;Strom 100 : 1
                MOV R6,#1

strom_gewhlt:  MOV R1,#LADEZYKLEN
neuer_zyklus:   MOV A,R6
                MOV R5,A                ;Auszeit in's Register 5
warte_aus:      CALL LADEN_WARTE
                DJNZ R5,warte_aus
strom_ein:      ANL P1,#%11111110       ;Laden Ein
                MOV A,R7
                MOV R5,A                ;"Einzeit" in's Register 0
warte_ein:      CALL LADEN_WARTE
                DJNZ R5,warte_ein
strom_aus:      ORL P1,#%00000001       ;Ladestrom ausschalten
                DJNZ R1,neuer_zyklus
                RETR

;--CHECK_ZYKLEN-- wieviele Lade / Entladezyklen mssen ausgefhrt werden

CHECK_ZYKLEN:   MOV R1,#34              ;Datenspeicher Programmwahl ffnen
                MOV A,@R1               ;und laden
                DEC A
                JZ z_zyklus_1           ;Programm 1 -> 1 Zyklus
                DEC A
                JZ z_zyklus_1           ;Programm 2 -> 1 Zyklus
                DEC A
                JZ z_zyklus_1           ;Programm 3 -> 1 Zyklus
                DEC A
                JZ z_zyklus_1           ;Programm 4 -> 1 Zyklus
                DEC A
                JZ z_zyklus_2           ;Programm 5 -> 2 Zyklen
                DEC A
                JZ z_zyklus_2           ;Programm 6 -> 2 Zyklen
                DEC A
                JZ z_zyklus_3           ;Programm 7 -> 3 Zyklen
                DEC A
                JZ z_zyklus_3           ;Programm 8 -> 3 Zyklen
z_zyklus_1:     MOV R1,#39              ;Zhlspeicher ffnen
                MOV @R1,#1              ;1 eintragen
                JMP ende_zyklen
z_zyklus_2:     MOV R1,#39              ;Zhlspeicher ffnen
                MOV @R1,#2              ;2 eintragen
                JMP ende_zyklen
z_zyklus_3:     MOV R1,#39              ;Zhlspeicher ffnen
                MOV @R1,#3              ;3 eintragen
ende_zyklen:    RETR

;--ENTPRELL-- Wartezeit Tasten entprellen

ENTPRELL:       MOV R0,#WARTE_ENTPRELL
E_warte_1:      MOV R3,#255
E_warte:        DJNZ R3,E_warte
                DJNZ R0,E_warte_1
                RETR

;--ANALOG_AUS-- gibt letzte Stelle Analog auf 7 Segment aus

ANALOG_AUS:     MOV R0,#32              ;Datenspeicher Analog ffnen
                MOV A,@R0               ;und laden
                ANL A,#%00001111        ;oberes Nibble weg
                CPL A                   ;vom Akku
                ADD A,#10               ;10 abziehen
                CPL A
                JNC a_a_addieren        ;wenn CARRY 0 -> Wert > 9
                MOV A,@R0
                JMP a_a_raus            ;Wert rausschreiben
a_a_addieren:   MOV A,@R0               ;zum Wert
                ADD A,#6                ;6 dazu
a_a_raus:       SEL RB1
                MOV R5,A
                SEL RB0
                RETR

;--AUS_LSTROM-- gewhlten Ladestrom auf die 7 Segment Anzeige

AUS_LSTROM:     MOV R0,#35              ;Datenspeicher 35 anwhlen
                MOV A,@R0               ;und Wert auf die
                SEL RB1                 ;Anzeige rausschreiben
                MOV R5,A
                SEL RB0
                RETR

;--EIN_AKKUANZAHL-- die Akkuanzahl eingeben und im Datenspeicher 33 speichern

EIN_AKKUANZAHL: CALL L_ZELLEN_EIN       ;Lumi Zellenanzahl einschalten
                MOV A,R4                ;Tastenspeicher laden
                CPL A
                JB7 ende_akku           ;Tasten ungltig -> beenden
                CPL A
                JB2 t_plus_akku         ;Taste + gedrckt
                JB3 t_minus_akku        ;Taste - gedrckt
                JMP ende_akku           ;Taste irrelevant, beenden
t_plus_akku:    CLR C
                MOV R0,#33              ;Datenspeicher Akkuanzahl
                MOV A,@R0               ;laden                                 
                CPL A
                ADD A,#9                ;vom Akku 9 abziehen
                CPL A
                JNC ende_akku           ;wenn Carry 0 maxWert (9) erreicht
                MOV A,@R0
                INC A                   ;Akku +1                               
                MOV @R0,A               ;Wert zurckschreiben                  
                JMP ende_akku           ;und beenden
t_minus_akku:   MOV R0,#33              ;Datenspeicher Akkuanzahl
                MOV A,@R0               ;laden                                 
                JZ ende_akku            ;raus, wenn Akkuanzahl 0 ist (Reset)
                DEC A
                JZ ende_akku            ;raus, wenn Akkuanzahl 1 ist
                DEC A
                JZ ende_akku            ;raus, wenn Akkuanzahl 2 ist
                INC A                   ;Akku +1 (da vorher 2* DEC A)
                MOV @R0,A               ;Wert zurckschreiben                  
ende_akku:      RETR


;--TIMER-- generiert "Blinkimpuls" / Interrupt / Flag 1 / 8243 versorgen

TIMER:          STOP TCNT               ;Timer anhalten
                SEL RB 1
                MOV R0,A                ;Akku retten
                MOV A,#TIMERINTERRUPT   ;Timer
                MOV T,A                 ;neu laden
                MOV R1,#40              ;Timerschleife 1 ffnen
                MOV A,@R1
                DEC A                   ;-1
                JZ gewartet_schl1       ;wenn Akku 0 -> Schleife 1 durch
                MOV @R1,A               ;Wert zurckschreiben
                JMP ende_timer
gewartet_schl1: DJNZ R2,ende_timer      ;Timerschleife 2 -1
                MOV R2,#BLINK           ;Register 2 neu laden
                MOV @R1,#10             ;Schleife 1 neu laden
                MOV R1,#41
                MOV A,@R1
                JB7 auf_null
                ORL A,#%10000000
                JMP zu_flag_1
auf_null:       ANL A,#%01111111
zu_flag_1:      CPL F1                  ;Blinkflag kippen
                MOV @R1,A
ende_timer:     CALL LUMI_LAUF
                CALL REGISTER_PORTS     ;8243 aktualisieren
                MOV A,R0                ;Akku restaurieren
                SEL RB0
                STRT T                  ;Timer wieder starten
                RETR

;--SUB_ERH_LADUNG-- generiert Zeitimpuls fr Start 1 Zyklus Erhaltensladung
;                   vom Datenspeicher 41 werden
;                   Bit 1 und Bit 2 belegt:
;                   Bit 1:  es mu nachgeladen werden (Nachladeimpuls)
;                   Bit 2:  R7 wurde decrementiert
S_ERH_LADUNG:   MOV R0,#42              ;Datenspeicher
                MOV A,@R0               ;Nachladezhler
                MOV R7,A                ;in's Register 7 schreiben
                JF1 s_erh_speich_l      ;Blinkflag 1 -> alle Speicher lschen
                MOV R1,#41              ;Flagspeicher ffnen
                MOV A,@R1               ;und laden
                JB2 s_erh_r7_dec        ;R7 wurde schon decrementiert
                DEC R7                  ;R7 -1
                MOV A,R7                ;und laden
                JZ s_erh_nachl          ;wenn R7 0 ist -> Erhaltensladeimpuls
                MOV A,@R1               ;Flagspeicher laden
                ORL A,#%00000100        ;Bit 2 (Speicher 1*decrementiert)
                MOV @R1,A               ;setzen und zurckschreiben
                JMP s_erh_ende          ;keinen Nachladeimpuls generieren
s_erh_nachl:    MOV R7,#TIMER_NACHLADEN ;R7 neu laden
                MOV A,@R1               ;Flagspeicher laden
                ORL A,#%00000110        ;Nachladen und Speicher setzen
                MOV @R1,A               ;und zurckschreiben
                JMP s_erh_ende
s_erh_r7_dec:   ANL A,#%11111101        ;nachladen lschen
                MOV @R1,A               ;und zurckschreiben
                JMP s_erh_ende
s_erh_speich_l: MOV R1,#41              ;Flagspeicher ffnen
                MOV A,@R1               ;und laden
                ANL A,#%11111001        ;Speicher und Nachladen lschen
                MOV @R1,A               ;und zurckschreiben
s_erh_ende:     MOV R0,#42              ;Datenspeicher 42 ffnen
                MOV A,R7                ;Register 7
                MOV @R0,A               ;im Datenspeicher 42 sichern
                RETR

;--Lumi Lauflicht ---------
LUMI_LAUF:      JF1 laufe_ende          ;wenn Blinkflag nicht gesetzt -> ende
                MOV R1,#41
                MOV A,@R1
                JB5 lauf_fertig         ;wenn Bit 5 gesetzt -> bereits gelaufen
                JB3 lauf_eladen         ;Lauflicht entladen
                JB4 lauf_laden          ;Lauflicht laden
                JMP laufe_ende          ;es gibt nichts zu laufen!
lauf_eladen:    MOV A,R7                ;Richtung P7.0 -> P7.1 -> P7.2
                CPL A
                JB2 eladen_loesch
                JB1 eladen_setze_2
                JB0 eladen_setze_1
                CPL A
                ANL A,#%11111110        ;setze Lumi P7.0
                MOV R7,A
                JMP setze_laufbit
eladen_setze_1: CPL A
                ANL A,#%11111101        ;setze Lumi P7.1
                MOV R7,A
                JMP setze_laufbit
eladen_setze_2: CPL A
                ANL A,#%11111011        ;setze Lumi P7.2
                MOV R7,A
                JMP setze_laufbit
eladen_loesch:  CPL A
                ORL A,#%00000111        ;lsche Lumis
                MOV R7,A
                JMP setze_laufbit
lauf_laden      MOV A,R7                ;Richtung P7.2 -> P7.1 -> P7.0
                CPL A
                JB0 laden_loeschen
                JB1 laden_setze_0
                JB2 laden_setze_1
                CPL A
                ANL A,#%11111011        ;setze P7.2
                MOV R7,A
                JMP setze_laufbit
laden_setze_1:  CPL A
                ANL A,#%11111101        ;setze P7.1
                MOV R7,A
                JMP setze_laufbit
laden_setze_0:  CPL A
                ANL A,#%11111110        ;setze P7.0
                MOV R7,A
                JMP setze_laufbit
laden_loeschen: CPL A
                ORL A,#%00000111        ;P7.0 - P7.2 lschen
                MOV R7,A
setze_laufbit:  MOV R1,#41
                MOV A,@R1
                ORL A,#%00100000        ;Bit 5 = Laufbit setzen
                MOV @R1,A
                JMP lauf_fertig
laufe_ende:     MOV R1,#41
                MOV A,@R1
                ANL A,#%11011111        ;Bit 5 = Laufbit rcksetzen
                MOV @R1,A
lauf_fertig:    RETR

                .END
